<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCPostFeed ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCPostFeed
 * @subpackage Arrays
 */
class ArrayOfCPostFeed extends AbstractStructArrayBase
{
    /**
     * The CPostFeed
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\CPostFeed[]
     */
    public $CPostFeed;
    /**
     * Constructor method for ArrayOfCPostFeed
     * @uses ArrayOfCPostFeed::setCPostFeed()
     * @param \RecruitCrm\LogicMelon\StructType\CPostFeed[] $cPostFeed
     */
    public function __construct(array $cPostFeed = array())
    {
        $this
            ->setCPostFeed($cPostFeed);
    }
    /**
     * Get CPostFeed value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\CPostFeed[]|null
     */
    public function getCPostFeed()
    {
        return isset($this->CPostFeed) ? $this->CPostFeed : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCPostFeed method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCPostFeed method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCPostFeedForArrayConstraintsFromSetCPostFeed(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCPostFeedCPostFeedItem) {
            // validation for constraint: itemType
            if (!$arrayOfCPostFeedCPostFeedItem instanceof \RecruitCrm\LogicMelon\StructType\CPostFeed) {
                $invalidValues[] = is_object($arrayOfCPostFeedCPostFeedItem) ? get_class($arrayOfCPostFeedCPostFeedItem) : sprintf('%s(%s)', gettype($arrayOfCPostFeedCPostFeedItem), var_export($arrayOfCPostFeedCPostFeedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CPostFeed property can only contain items of type \RecruitCrm\LogicMelon\StructType\CPostFeed, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CPostFeed value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\CPostFeed[] $cPostFeed
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfCPostFeed
     */
    public function setCPostFeed(array $cPostFeed = array())
    {
        // validation for constraint: array
        if ('' !== ($cPostFeedArrayErrorMessage = self::validateCPostFeedForArrayConstraintsFromSetCPostFeed($cPostFeed))) {
            throw new \InvalidArgumentException($cPostFeedArrayErrorMessage, __LINE__);
        }
        if (is_null($cPostFeed) || (is_array($cPostFeed) && empty($cPostFeed))) {
            unset($this->CPostFeed);
        } else {
            $this->CPostFeed = $cPostFeed;
        }
        return $this;
    }
    /**
     * Add item to CPostFeed value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\CPostFeed $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfCPostFeed
     */
    public function addToCPostFeed(\RecruitCrm\LogicMelon\StructType\CPostFeed $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\CPostFeed) {
            throw new \InvalidArgumentException(sprintf('The CPostFeed property can only contain items of type \RecruitCrm\LogicMelon\StructType\CPostFeed, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CPostFeed[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\CPostFeed|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\CPostFeed|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\CPostFeed|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\CPostFeed|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\CPostFeed|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CPostFeed
     */
    public function getAttributeName()
    {
        return 'CPostFeed';
    }
}
